#ifndef gf_included_Faces_h
#define gf_included_Faces_h

#include <stdio.h>
#include <stdlib.h>

//This is a vertex.
struct KVertex
{
 double X;
 double Y;
 double Z;    
};

typedef struct KVertex kvertex;


//A face is made up of 3 or 4 vertices, depending on
//whether the list stores triangles or quads.
struct KFace
{
 double NormalX;  //The normals to this face.
 double NormalY;
 double NormalZ;
 kvertex VArray[4];  //The vertices to this face.
 int NumVertices;  //How many vertices being used.
};

typedef struct KFaceList klist;
typedef struct KNode knode;
typedef struct KFace kface;


//A face.
struct KNode
{
 kface theFace;

 knode* next;
};


//A list of faces.
struct KFaceList
{
 knode* Head;      
 knode* Current;
 
 int ColorCode;  //The color code used in picking.
};

//I'm not gonna document these functions.
//All they do is set up a bunch of KLists for all of my objects
//in the game.  In other words...LOTS of vertex definitions.

void freeList(klist theList);
klist addNode(klist theList, kface theFace);
klist ResetList(klist theList);
klist CreateBoxRim();
klist CreateBox();
klist CreateArrowStem();
klist CreateArrowTop();
klist CreateArrowRim();
klist CreateExit();
klist CreateTrap();
klist CreateTrapEdge();
klist CreateSwitchBox();
klist CreateSwitch();
klist CreatePidFace();
klist CreatePidBody();
klist CreatePidFront();
klist CreatePidFeet();
klist CreateGolemEnds();
klist CreateCrystal();
klist CreateWallBounds();
klist CreateSky();
klist CreateHole();
klist CreateHUD();
klist CreateMenus();

klist CreateBackground();
klist CreateWallBottom();
klist CreateWallNorth();
klist CreateWallEast();
klist CreateWallSouth();
klist CreateWallWest();

#endif
