#ifndef gf_included_Painter_h
#define gf_included_Painter_h

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#include "types.h"
#include "PlayTile.h"
#include "eWallTile.h"
#include "eLevel.h"
#include "Faces.h"
/*
Valid painter labels include:
      
      PID
      CRYSTAL
      CLOSEDEXIT
      OPENEXIT
      ALLY
      GOLEM
      FURY  //same as Pid.
      FLAME //Opposite to Pid.
      SWITCH
      DIRT
      TRAP
      ARROW
      HVBLOCK
      VBLOCK
      HBLOCK
      DBLOCK
*/

//Pulled directly from NeHe tutorials.  I'm hoping to go pure Targa for my
//image files, hence making MUCH better code.
typedef	struct										// Create A Structure
{
	GLubyte	*imageData;								// Image Data (Up To 32 Bits)
	GLuint	bpp;									// Image Color Depth In Bits Per Pixel
	GLuint	width;									// Image Width
	GLuint	height;									// Image Height
	GLuint	texID;									// Texture ID Used To Select A Texture
} TextureImage;										// Structure Name

void PaintCharacter(PlayTile theTile);
void LoadGraphics();
//This function loads all the graphics from the Graphics folder.
void PaintInfo(char* Out);
void PaintString(double x, double y, void* font, char* string);
//This will paint a string using glutBitmapCharacter.  It makes newlines for \n and skips over _.
void PaintCursor(int X, int Y, bool Move);
void PaintMapBottom();
void PaintHoles(eLevel theLevel);
void PaintFloor(WallTile theWall, int x, int y);
void PaintWall(WallTile theWall, int x, int y);
//Paints the walls based on the information it can glean from the walltile.

void ExitGraphics(); //Cleans up memory used by OpenGL.

#endif
