#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "Painter.h"
#include "eLevel.h"

char* OutLevel;
eLevel editLevel;
PlayTile PlayLayer[10][10];
eCursor editCursor;

void ClearTiles()
{
 for(int i = 0; i < 10; i++)
   for(int j = 0; j < 10; j++)
     PlayLayer[i][j].Name = "EMPTY";    
}

eLevel newLevel(char* File)
{
 eLevel theLevel;
 theLevel.Size = 10;
 
 for(int i = 0; i < theLevel.Size; i++)
   for(int j = 0; j < theLevel.Size; j++)
     theLevel.Walls[i][j] = MakeWallTile(BNONE);
 OutLevel = File;
 return theLevel;
}

void SaveLevel()
{
 FILE* save = fopen(OutLevel, "w");      
 if(!save)
 {
  printf("Error - Cannot save level.\r\n");
  return;      
 }
 for(int j = 0; j < editLevel.Size; j++)
 {
  for(int i = 0; i < editLevel.Size; i++)
  {
   if(editLevel.Walls[i][j].Blocking == BNONE) fputc('0', save);
   else if(editLevel.Walls[i][j].Blocking == BNORTH) fputc('1', save);   
   else if(editLevel.Walls[i][j].Blocking == BEAST) fputc('2', save);
   else if(editLevel.Walls[i][j].Blocking == BSOUTH) fputc('3', save);
   else if(editLevel.Walls[i][j].Blocking == BWEST) fputc('4', save);
   else if(editLevel.Walls[i][j].Blocking == BNORTHEAST) fputc('5', save);
   else if(editLevel.Walls[i][j].Blocking == BNORTHSOUTH) fputc('6', save);
   else if(editLevel.Walls[i][j].Blocking == BNORTHWEST) fputc('7', save);
   else if(editLevel.Walls[i][j].Blocking == BEASTSOUTH) fputc('8', save);
   else if(editLevel.Walls[i][j].Blocking == BEASTWEST) fputc('9', save);
   else if(editLevel.Walls[i][j].Blocking == BSOUTHWEST) fputc('A', save);
   else if(editLevel.Walls[i][j].Blocking == BNORTHEASTSOUTH) fputc('B', save);
   else if(editLevel.Walls[i][j].Blocking == BEASTSOUTHWEST) fputc('C', save);
   else if(editLevel.Walls[i][j].Blocking == BSOUTHWESTNORTH) fputc('D', save);       
   else if(editLevel.Walls[i][j].Blocking == BWESTNORTHEAST) fputc('E', save);      
   else if(editLevel.Walls[i][j].Blocking == BALL) fputc('F', save);    
  }               
  fputc('\n', save);
 }
 for(int j = 0; j < editLevel.Size; j++)
 {
  for(int i = 0; i < editLevel.Size; i++)
  {
   if(editLevel.Walls[i][j].Colour == ISRED || editLevel.Walls[i][j].Colour == ISYELLOW ||
      editLevel.Walls[i][j].Dirty || editLevel.Walls[i][j].Hole)
   {
    int x = i;
    int y = j;
    int Colour = 0;
    int Hole = 0;
    int Dirty = 0;
    if(editLevel.Walls[i][j].Colour == ISRED) Colour = 1;
    else if(editLevel.Walls[i][j].Colour == ISYELLOW) Colour = 2;
    if(editLevel.Walls[i][j].Dirty) Dirty = 1;
    if(editLevel.Walls[i][j].Hole) Hole = 1;
    fprintf(save, "W %d %d %d %d %d\n", x, y, Colour, Dirty, Hole);
   } 
  }        
 }
 for(int j = 0; j < editLevel.Size; j++)
 {
  for(int i = 0; i < editLevel.Size; i++)
  {
   if(strcmp(PlayLayer[i][j].Name, "EMPTY") != 0)
   {
    int x = PlayLayer[i][j].X;
    int y = PlayLayer[i][j].Y;
    int Colour = 0;
    if(PlayLayer[i][j].Colour == ISRED || PlayLayer[i][j].Colour == SETRED) Colour = 1;
    else if(PlayLayer[i][j].Colour == ISYELLOW || PlayLayer[i][j].Colour == SETYELLOW) Colour = 2;
    int Move = 0;
    if(PlayLayer[i][j].Moveable) Move = 1;
    int Point = (int) PlayLayer[i][j].PointDirection;
    fprintf(save, "P %d %d %d %d %d %s\n", x, y, Colour, Move, Point, PlayLayer[i][j].Name);    
   }
  }
 }
 fclose(save);
}

eLevel LoadLevel(char* FileName)
{
 int i;
 
 eLevel theLevel; 
 theLevel.Size = 10;
 FILE* NewLevel = fopen(FileName,"r");		//This opens a File so we can read it in line by line.  

 if (!NewLevel)
 {
  return newLevel(FileName);
 }
 OutLevel = FileName; 
 int LineCounter = 0;		//This will make sure we only count 10 lines into the Stage array.  So if there is any
 char nextLevelLine[27];	// more level data, it gets ignored.
 
 while (fgets(nextLevelLine,27,NewLevel)!=NULL && LineCounter < theLevel.Size)
 { 
  for(i = 0; i < theLevel.Size; i++)
  {
   if(nextLevelLine[i] == '0') theLevel.Walls[i][LineCounter] = MakeWallTile(BNONE);
   else if(nextLevelLine[i] == '1') theLevel.Walls[i][LineCounter] = MakeWallTile(BNORTH);
   else if(nextLevelLine[i] == '2') theLevel.Walls[i][LineCounter] = MakeWallTile(BEAST);
   else if(nextLevelLine[i] == '3') theLevel.Walls[i][LineCounter] = MakeWallTile(BSOUTH);
   else if(nextLevelLine[i] == '4') theLevel.Walls[i][LineCounter] = MakeWallTile(BWEST);
   else if(nextLevelLine[i] == '5') theLevel.Walls[i][LineCounter] = MakeWallTile(BNORTHEAST);
   else if(nextLevelLine[i] == '6') theLevel.Walls[i][LineCounter] = MakeWallTile(BNORTHSOUTH);
   else if(nextLevelLine[i] == '7') theLevel.Walls[i][LineCounter] = MakeWallTile(BNORTHWEST);
   else if(nextLevelLine[i] == '8') theLevel.Walls[i][LineCounter] = MakeWallTile(BEASTSOUTH);
   else if(nextLevelLine[i] == '9') theLevel.Walls[i][LineCounter] = MakeWallTile(BEASTWEST);
   else if(nextLevelLine[i] == 'A') theLevel.Walls[i][LineCounter] = MakeWallTile(BSOUTHWEST);
   else if(nextLevelLine[i] == 'B') theLevel.Walls[i][LineCounter] = MakeWallTile(BNORTHEASTSOUTH);
   else if(nextLevelLine[i] == 'C') theLevel.Walls[i][LineCounter] = MakeWallTile(BEASTSOUTHWEST);
   else if(nextLevelLine[i] == 'D') theLevel.Walls[i][LineCounter] = MakeWallTile(BSOUTHWESTNORTH);
   else if(nextLevelLine[i] == 'E') theLevel.Walls[i][LineCounter] = MakeWallTile(BWESTNORTHEAST);
   else if(nextLevelLine[i] == 'F') theLevel.Walls[i][LineCounter] = MakeWallTile(BALL);
  }       
  LineCounter++;
  printf("%s", nextLevelLine);	
 }
 do
 {
  if(nextLevelLine[0] == 'P')
  {
    int x, y, colour, move, point;
    char* Name = (char*)malloc(512);
    char Ind;
    sscanf(nextLevelLine, "%c %d %d %d %d %d %s", &Ind, &x, &y, &colour, &move, &point, Name);
    printf("%c %d %d %d %d %d %s\r\n", Ind, x, y, colour, move, point, Name);
    
    ColourType Col;
    if(colour == 0) Col = ISGREY;
    else if(colour == 1) Col = ISRED;
    else Col = ISYELLOW;
    
    PointAt PAt;
    
    if(point == 0) PAt = PNONE;
    else if(point == 1) PAt = PNORTH;
    else if(point == 2) PAt = PEAST;
    else if(point == 3) PAt = PSOUTH;
    else PAt = PWEST;
    
    PlayLayer[x][y] = MakeStandardTile(Name, Col, move, PAt, x, y);
  }
  else if(nextLevelLine[0] == 'W')
  {
   int x, y, colour, dirty, hole;
   char Ind;
   sscanf(nextLevelLine, "%c %d %d %d %d %d", &Ind, &x, &y, &colour, &dirty, &hole);
   printf("%c %d %d %d %d %d\r\n", Ind, x, y, colour, dirty, hole);   
  
   ColourType Col;
   if(colour == 0) Col = ISGREY;
   else if(colour == 1) Col = ISRED;
   else if(colour == 2) Col = ISYELLOW;
   
   theLevel.Walls[x][y].Colour = Col;
   theLevel.Walls[x][y].Dirty = dirty;
   theLevel.Walls[x][y].Hole = hole;
  }
 }while(fgets(nextLevelLine,27,NewLevel) != NULL);
 
 fclose(NewLevel);
 return theLevel;
}

void PaintMap()
{     
 //When we ask it to give us the reflection... We reverse Y so that it paints the whole map upside-down.
 glPushMatrix();
 glScalef(0.5, 0.5, 0.5); //This shrinks the map so that the animation isn't too jerky.
 PaintMapBottom();  

  for(int i = 0; i < editLevel.Size; i++)
    for(int j = 0; j < editLevel.Size; j++)
      PaintWall(editLevel.Walls[i][j], i, j);

 //Paint the shimmering or dirt in the floor.
 for(int i = 0; i < editLevel.Size; i++)
  for(int j = 0; j < editLevel.Size; j++)
    PaintFloor(editLevel.Walls[i][j], i, j); 
   
 for(int i = 0; i < editLevel.Size; i++)
  for(int j = 0; j < editLevel.Size; j++)
    PaintCharacter(PlayLayer[i][j]);  
 
 PaintCursor(editCursor.X, editCursor.Y, PlayLayer[editCursor.X][editCursor.Y].Moveable); 
 PaintHoles(editLevel);
 glPopMatrix(); 
}

void MoveWest()
{
 editCursor.X--;
 if(editCursor.X < 0) editCursor.X = 0;
}

void MoveEast()
{
 editCursor.X++;
 if(editCursor.X >= editLevel.Size) editCursor.X = editLevel.Size-1;
}

void MoveNorth()
{
 editCursor.Y--;
 if(editCursor.Y < 0) editCursor.Y = 0;
}

void MoveSouth()
{
 editCursor.Y++;
 if(editCursor.Y >= editLevel.Size) editCursor.Y = editLevel.Size-1;
}

void FChangeWall()
{
 int move = editLevel.Walls[editCursor.X][editCursor.Y].Blocking + 1;
 if(move > 15) move = 15;     
 editLevel.Walls[editCursor.X][editCursor.Y] = MakeWallTile((StopType) move);
}

void BChangeWall()
{
 int move = editLevel.Walls[editCursor.X][editCursor.Y].Blocking - 1;
 if(move < 0) move = 0;     
 editLevel.Walls[editCursor.X][editCursor.Y] = MakeWallTile((StopType) move); 
}

void DisplayCallback()
{          
 // clear the color buffer
  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
  // set up camera  
  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluPerspective( 45, 1.3, 1.0, 1200.0 ); 
  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity();
  //Otherwise we just alter the lookat to give us that trackball feel.
  gluLookAt(1.5, 7, 5, 1.5, 1, 3, 0, 1, 0); 
  PaintMap(); //Paint the actual level.

  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glLoadIdentity();
  gluOrtho2D(0, 800, 0, 600);  //Get all 2D and draw the strings which
  glScalef(1, -1, 1); //tell the user information such as level name and help info.
                       //I made the screen 800x600 since I was dealing with a Windowed version
                       //of the game earlier.  It makes no difference that I switched it...since
                       //Ortho...does it...anyway.  Trust me, it's fine.
  glTranslatef(0, -600, 0);
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glLoadIdentity();   
  PaintInfo(OutLevel);
  glPopMatrix();
  glPopMatrix();
  
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);  	
  glutSwapBuffers(); //Otherwise, actually show the user what's going on.
}

void CleanUpExit() //This function deallocates memory and gives the user back his computer.
{
 ExitGraphics();
 exit(0);
}
 
void KeyboardDown(unsigned char c, int x, int y) {
  switch (c) 
  {
    case 27:
      CleanUpExit();
      break;
    case 'a':
      MoveWest();
      break;      
    case 's':
      MoveSouth();
      break;    
    case 'w':
      MoveNorth();
      break;    
    case 'd':
      MoveEast();
      break;
    case 'y':
      editLevel.Walls[editCursor.X][editCursor.Y].Colour = ISYELLOW; 
      break;
    case 'Y':
      PlayLayer[editCursor.X][editCursor.Y].Colour = ISYELLOW; 
      break;    
    case 'g':
      editLevel.Walls[editCursor.X][editCursor.Y].Colour = ISGREY;
      break;
    case 'G':
      PlayLayer[editCursor.X][editCursor.Y].Colour = ISGREY; 
      break;      
    case 'r':
      editLevel.Walls[editCursor.X][editCursor.Y].Colour = ISRED;
      break;
    case 'R':
      PlayLayer[editCursor.X][editCursor.Y].Colour = ISRED;
      break; 
    case 'm':
      PlayLayer[editCursor.X][editCursor.Y].Moveable = !PlayLayer[editCursor.X][editCursor.Y].Moveable;
      break;     
    case 'h':
      editLevel.Walls[editCursor.X][editCursor.Y].Hole = !editLevel.Walls[editCursor.X][editCursor.Y].Hole;
      break;
    case 'j':
      editLevel.Walls[editCursor.X][editCursor.Y].Dirty = !editLevel.Walls[editCursor.X][editCursor.Y].Dirty; 
      break;
    case ',':
    case '<':
      BChangeWall();  
      break;           
    case '.':
    case '>':
      FChangeWall();       
      break;
    case 'f':
      SaveLevel();
      printf("\n - Level Saved.\r\n");
      break;
    case '~':
    case '`':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("EMPTY", ISGREY, false, PNONE, editCursor.X, editCursor.Y); 
       break;
    case '1':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("PID", ISGREY, true, PNONE, editCursor.X, editCursor.Y); 
       break;
    case '2':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("CRYSTAL", ISGREY, false, PNONE, editCursor.X, editCursor.Y); 
       break;       
    case '3':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("CLOSEDEXIT", ISGREY, false, PNONE, editCursor.X, editCursor.Y); 
       break;              
    case '4':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("ALLY", ISGREY, true, PNONE, editCursor.X, editCursor.Y); 
       break;                     
    case '5':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("GOLEM", ISGREY, true, PNONE, editCursor.X, editCursor.Y); 
       break;                            
    case '6':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("FURY", ISGREY, true, PNONE, editCursor.X, editCursor.Y); 
       break;                                   
    case '7':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("FLAME", ISGREY, true, PNONE, editCursor.X, editCursor.Y); 
       break;
    case '8':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("SWITCH", ISYELLOW, false, PNONE, editCursor.X, editCursor.Y); 
       break;       
    case '9':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("SWITCH", ISRED, false, PNONE, editCursor.X, editCursor.Y); 
       break;              
    case '0':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("TRAP", ISGREY, false, PNONE, editCursor.X, editCursor.Y); 
       break;              
    case '!':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("ARROW", ISGREY, false, PNORTH, editCursor.X, editCursor.Y); 
       break;              
    case '@':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("ARROW", ISGREY, false, PEAST, editCursor.X, editCursor.Y); 
       break;                            
    case '#':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("ARROW", ISGREY, false, PSOUTH, editCursor.X, editCursor.Y); 
       break;                            
    case '$':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("ARROW", ISGREY, false, PWEST, editCursor.X, editCursor.Y); 
       break;                                          
    case '%':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("HVBLOCK", ISGREY, false, PNONE, editCursor.X, editCursor.Y); 
       break;        
    case '^':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("VBLOCK", ISGREY, false, PNONE, editCursor.X, editCursor.Y); 
       break;        
    case '&':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("HBLOCK", ISGREY, false, PNONE, editCursor.X, editCursor.Y); 
       break;               
    case '*':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("DBLOCK", ISGREY, false, PNONE, editCursor.X, editCursor.Y); 
       break;               
  }

  glutPostRedisplay();  
}

void onIdle()
{     
 glutPostRedisplay();       
}

int main(int argc, char*argv[])
{ 
  ClearTiles();
  char* name;  
  if(argc <= 1)
  {
   printf("Okay this is how it works.  Enter in a level name below.  It will save the \n");
   printf("level exactly as you type it.  So type '<name>.lvl' instead of just <name>.\n\n");
   printf("When you save your level, you'll need to add it to the WLD file as\n");
   printf("described in the readme in order to play your creation.\n\n");
   printf("Once you enter the level name.  Hit Alt+Tab to switch to the editor.\n\n");
   printf("Enter Level: ");

   scanf("%s", name);
  }
  else name = argv[1];
  
  editLevel = LoadLevel(name);

  glutInit( &argc, argv );
  glutInitDisplayMode( GLUT_DEPTH | GLUT_RGB | GLUT_DOUBLE );
  glutInitWindowSize( 800, 600 );
  glutCreateWindow("Kouriku Level Editor");
  // register display callback
  
  glutDisplayFunc( DisplayCallback );
  glutKeyboardFunc( KeyboardDown );
  glutIdleFunc(onIdle); 
  glViewport( 0, 0, 800, 600 ); 
 
  glEnable( GL_DEPTH_TEST );  
  LoadGraphics();  //Load all the textures.  This takes awhile since it's about 10Mb worth.

  glDisable( GL_LIGHTING );
  glEnable( GL_COLOR_MATERIAL );

  // pass control over to GLUT 
  glutMainLoop();
  
  return 0;       // never reached
}


