#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "Level.h"


PlayTile TestWalls(Level theLevel, PlayTile theTile)
//This function checks to see if the playtile is even allowed to move in the direction
//it wants.  It checks against the walls it could run into in both the spot it is at
//and the new spot it wishes to move to.  If the coast is clear, it allows the tile
//to continue moving.
{
 if(theTile.Moving == STOPPED || theTile.Moving == PUSH) return theTile;

 if(theLevel.Walls[theTile.X][theTile.Y].Hole)
 {
  theTile.RemoveMe = true;
  return theTile;
 }

 if(theLevel.Walls[theTile.X][theTile.Y].Dirty && !theTile.Dirty) 
 {
   if(theTile.InTheWay) theTile.Moving = STOPPED;
   theTile.Dirty = true;
   return theTile;
 }
 else if(theTile.Dirty) theTile.Dirty = false;
 
 if(theLevel.Walls[theTile.X][theTile.Y].Colour != ISGREY &&
         theLevel.Walls[theTile.X][theTile.Y].Colour != theLevel.Active){} 
 else if(theLevel.Walls[theTile.X][theTile.Y].Blocks[theTile.Moving-1]) theTile.Moving = STOPPED;
 int x = theTile.X;
 int y = theTile.Y;
 if(theTile.Moving == NORTH) y--;
 else if(theTile.Moving == SOUTH) y++;
 else if(theTile.Moving == WEST) x--;
 else if(theTile.Moving == EAST) x++;

 if(x >= 0 && x < theLevel.Size && y >= 0 && y < theLevel.Size)
 {
  int Blocks = theTile.Moving+2;
  if(Blocks > WEST) Blocks = (Blocks % 5) + 1;
  if(theLevel.Walls[x][y].Colour != ISGREY &&
         theLevel.Walls[x][y].Colour != theLevel.Active){} 
  else if(theLevel.Walls[x][y].Blocks[Blocks-1]) theTile.Moving = STOPPED; 
 }
 
 return theTile;        
}


