#ifndef gf_included_Map_h
#define gf_included_Map_h

#include "Level.h"
#include "list.h"

//A Nudge is letting the driver of special events.  This is for the purpose of sound
//effects and further animations to take place on the board.
//1 is explosion.
//2 is falling down a hole.
//3 is collecting a crystal.
//4 is changing the active colour.
//5 is when a Golem or Box stops moving.

struct Dmarker
{
 int x;  //The x and y co-ordinates of the marker to be recorded.
 int y;       
 int Type; //Type of nudge, being Explosion (1) or Hole Flash (2), etc.
};

typedef struct Dmarker DMarker;

struct Kmap
{
 bool AnimateBusy;  //If this flag is set, it means that the Painter is still busy
                    //and that I shouldn't be continuing tile interactions just yet.
       
 TList PlayList;  //List of the tiles on the board.
 Level aLevel;    //The board itself. 
};

typedef struct Kmap KMap;

void StartRecording();
void StopRecording();

KMap LoadMap(char* FileName);
//This function loads the list of tiles and the board.  If you wanna see how I read
//the data from the level files, this would be the place to go.
KMap MoveNorth(KMap theMap);
//This is called when the player wants to move north.
KMap MoveWest(KMap theMap);
//Similar.
KMap MoveSouth(KMap theMap);
KMap MoveEast(KMap theMap);
KMap Interaction(KMap theMap);
//This runs the next round of interactions between tiles on the board.  
KMap CheckAnimation(KMap theMap);
//This checks to see if the Painter X, Y are caught up with each Tile's new X, Y position.
//If it's still busy, it sets the flag for it.
bool Winner(KMap theMap);
//This informs us of winning
bool Loser(KMap theMap);
//and this of losing.
int GetMoves(KMap theMap);
//Tells us the number of moves taken on this map.
DMarker GetNudge(int MarkerNumber);

#endif
