#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "Menu.h"
#include "World.h"

int Screen = STITLE;

double StartX = 275;
double StartY = 190;
double SaveX = 50;
double SaveY = 150;
double ConfirmX = 200;
double ConfirmY = 30;
bool ChangingWorlds = false;

double IconX = StartX;
double IconY = StartY;
char SaveCall[80];
double FluxX = 0;
double FluxY = 0;
bool ReverseX = false;
bool ReverseY = false;
bool ShiftLeft = false; //if the map should be shifted left or right when asked for it.


int NumWorlds = 0;
World* Worlds = LoadWorlds(NumWorlds);
int CurrentWorld = 0;
char* PlayerName;
char PlayerFile[13];
int aTotalComplete = 0;
int aTotalMoves = 0;
bool PlayerTime = false;

int SavePointer = 0;
bool NewGame[4];
char NewName[] = "_        ";
int NamePointer = 0;

bool ChangedWorld()
{
 bool newC = ChangingWorlds;
 ChangingWorlds = false;
 return newC;    
}

void ResetAllWorlds()
{
 for(int i = 0; i < NumWorlds; i++)
   Worlds[i] = ResetWorld(Worlds[i]);         
 CurrentWorld = 0;
}
void SetTotalMoves(int pTotalMoves){ aTotalMoves = pTotalMoves; }
int GetTotalMoves(){ return aTotalMoves;  }
void SetTotalComplete(int pTotalComplete){ aTotalComplete = pTotalComplete; }
int GetTotalComplete(){ return aTotalComplete; }

bool isNewGame(){ return NewGame[SavePointer]; }

void ClearNewName()
{
NewName[0] = '_';
for(int i = 1; i < 9; i++) NewName[i] = ' ';
NamePointer = 0;     
}
char* GetPlayerName()
{
 return PlayerName;     
}

void ChangeNewName(char c)
{
 NewName[NamePointer] = c; 
 NamePointer++;
 if(NamePointer > 8) NamePointer = 8;    
 else NewName[NamePointer] = '_';
}
void BackspaceNewName()
{
 if(NewName[NamePointer] == '_')
 {
  NewName[NamePointer] = ' ';
  NamePointer--; 
  NewName[NamePointer] = '_';
 } else NewName[NamePointer] = '_';
 if(NamePointer < 0) NamePointer = 0;
}

char* GetNewName()
{
 return NewName;     
}

void PassOnName(char* Name)
{
 PlayerName = Name;    
}

bool ShiftingLeft()
{
 return ShiftLeft;   
}

void NextWorld()
{
 int lastWorld = CurrentWorld;
 CurrentWorld = atoi(Worlds[CurrentWorld].Current->Filename) - 1;
 if(lastWorld < CurrentWorld) ShiftLeft = true;
 else ShiftLeft = false;
 
 if(CurrentWorld >= NumWorlds){ printf("World %d does not exist.\r\n", CurrentWorld+1); exit(1); }
}

char* GetWorldBackground()
{
 return Worlds[CurrentWorld].Backg;
}

char* GetWorldSky()
{
 return Worlds[CurrentWorld].Sky;
}

char* GetWorldWall()
{
  return Worlds[CurrentWorld].Wall;  
}

char* GetLevelByFile()
{
 return Worlds[CurrentWorld].Current->Filename;     
}

void UpdateWorldMap(int pLevelID, int pNumMoves)
{
 int Search = 0;
 
 while(Search < NumWorlds)
 {
  LevelNode* Next = Worlds[Search].Head;
  while(Next != NULL)
  {
   if(Next->LevelID == pLevelID)
   {
    Next->NumMoves = pNumMoves;                
   } 
   Next = Next->next;          
  }
  Search++;            
 }    
}

bool isConfirm = false;
bool Confirm()
{
 return isConfirm;    
}

char* GetSaveInfo()
{
 return SaveCall;     
}

void SetupSaveMenu(char pCallback[])
{
 strcpy(SaveCall, pCallback);

 int NumMoves[4];
 int NumLevels[4];
 char* Name[4];
 Name[0] = (char*) malloc(128); 
 Name[1] = (char*) malloc(128); 
 Name[2] = (char*) malloc(128); 
 Name[3] = (char*) malloc(128);    

 sscanf(SaveCall, "%d %d %s %d %d %s %d %d %s %d %d %s %d %d %s",
 &NumLevels[0], &NumMoves[0], Name[0],  &NumLevels[1], &NumMoves[1], Name[1],
 &NumLevels[2], &NumMoves[2], Name[2],  &NumLevels[3], &NumMoves[3], Name[3]);
 
 if(strcmp(Name[0], "<nothing>") == 0) NewGame[0] = true;
 else NewGame[0] = false;
 if(strcmp(Name[1], "<nothing>") == 0) NewGame[1] = true;
 else NewGame[1] = false;
 if(strcmp(Name[2], "<nothing>") == 0) NewGame[2] = true;
 else NewGame[2] = false;
 if(strcmp(Name[3], "<nothing>") == 0) NewGame[3] = true;
 else NewGame[3] = false;
     
 free(Name[0]);
 free(Name[1]);
 free(Name[2]);
 free(Name[3]); 
}

void ResetWorldMap()
{
 int Search = 0;
 
 while(Search < NumWorlds)
 {
  LevelNode* Next = Worlds[Search].Head;
  while(Next != NULL)
  {
    Next->NumMoves = -1;  
    Next = Next->next;
  }
  Search++;            
 }    
}

int GetLevelByID()
{
 return Worlds[CurrentWorld].Current->LevelID;   
}

int GetLevelByNumMoves()
{
 return Worlds[CurrentWorld].Current->NumMoves;   
}

void OutOfGame()
{
 Screen = SWORLD;          
}

char* GetWorldName()
{
 return Worlds[CurrentWorld].Name;     
}

char* GetLevelName()
{
 return Worlds[CurrentWorld].Current->Name;     
}

double GetWorldX()
{
 return Worlds[CurrentWorld].Current->X;      
}

double GetWorldY()
{
 return Worlds[CurrentWorld].Current->Y;      
}

void IncreaseMenuOption()
{
 if(Screen == STITLE)
 {
  IconX = StartX;
  IconY += 35;
  if(IconY > 280) IconY = StartY;
 }  
 else if(Screen == SSAVE)
 {
  if(Confirm())
  {
   IconY = ConfirmY;
   if(IconX == ConfirmX) IconX += 250; 
   else IconX -=250;    
  }
  else
  {
   IconX = SaveX;
   IconY += 120;
   SavePointer++;
   if(IconY > 530){ IconY = SaveY;  SavePointer = 0; }
  }
 }     
 else if(Screen == SWORLD)
 {
  Worlds[CurrentWorld] = nextLevel(Worlds[CurrentWorld]);
 }                   
}

void DecreaseMenuOption()
{
 if(Screen == STITLE)
 {
  IconX = StartX;
  IconY -= 35;
  if(IconY < StartY) IconY = 260;
 }      
 else if(Screen == SSAVE)
 {
  if(Confirm())
  {
   IconY = ConfirmY;
   if(IconX == ConfirmX) IconX += 250; 
   else IconX -=250;    
  }
  else
  {      
   IconX = SaveX;
   IconY -= 120;
   SavePointer--;
   if(IconY < SaveY){ IconY = 510; SavePointer = 3; }
  }
 }   
 else if(Screen == SWORLD)
 {
  Worlds[CurrentWorld] = prevLevel(Worlds[CurrentWorld]);
 }         
}

bool Replay()
{
  if(Screen == SWORLD)
  {
   Screen = SDONE;
   return true;
  }
  else return false;   
}

bool TimeToLoadPlayer()
{
 bool temp = PlayerTime;
 PlayerTime = false;
 
 return temp;    
}

void SuccessfulLoad()
{
 Screen = SWORLD;    
}

char* GetPlayerFile()
{
 return PlayerFile;     
}

bool InGame()
{
 if(Screen == SDONE) return true;
 else return false;    
}

void SwitchInHelpMenu()
{
 Screen++;
 if(Screen > SHELP3) Screen = STITLE;        
}

int GetScreen() { return Screen; }

double GetMenuX(bool Anim) 
{ 
 if(!ReverseX && Anim)
 {
   FluxX += 0.1;
   if(FluxX > 1) ReverseX = !ReverseX;
 }
 else if(Anim)
 {
   FluxX -= 0.1;
   if(FluxX < -1)
   {
    ReverseX = !ReverseX;
    ReverseY = !ReverseY;
   }
 } 
 
 return IconX + FluxX; 
}
double GetMenuY(bool Anim) 
{ 
 if(Anim)
 {
  if(ReverseY) FluxY += 0.05;        
  else FluxY -= 0.05;
 }
       
 return IconY + FluxY;
}

bool ProcessOption()
{
 if(Screen == STITLE) 
 {
  if(IconY < 200){ Screen = SSAVE; IconY = SaveY; IconX = SaveX; SavePointer = 0; }
  else if(IconY < 230 && IconY > 210) Screen = SHELP1;
  else if(IconY > 250) 
  {
   return DeProcessOption();
  }
 }
 else if(Screen < SWORLD)
  SwitchInHelpMenu();   
 else if(Screen == SSAVE)
 {
  if(Confirm() && !isNewGame())
  {
   if(IconX == ConfirmX)
   {
    Screen = SWORLD;
    PlayerFile[0] = 'C';
   
    PlayerTime = true;
    isConfirm = false; 
   }
   else
   {
    PlayerFile[0] = 'D';
    PlayerTime = true;
    isConfirm = false;  
    IconX = SaveX;
    IconY = SaveY;
    SavePointer = 0;  
   }
  }
  else if(Confirm() && isNewGame())
  {
    PlayerFile[0] = 'N';
    if(NamePointer < 8) NewName[NamePointer] = ' ';
    PlayerTime = true;
    isConfirm = false; 
    SavePointer = 0;
  }
  else 
  { 
   if(SavePointer == 0) strcpy(PlayerFile," player1.sav");
   else if(SavePointer == 1) strcpy(PlayerFile," player2.sav");
   else if(SavePointer == 2) strcpy(PlayerFile," player3.sav");
   else if(SavePointer == 3) strcpy(PlayerFile," player4.sav");
   
   isConfirm = true; IconX = ConfirmX; IconY = ConfirmY; 
  }  
 }
 else if(Screen == SWORLD) 
 {
  if(ChangeWorld(Worlds[CurrentWorld])) 
    { 
      int temp = CurrentWorld;
      NextWorld(); 
      Worlds[temp] = ResetWorld(Worlds[temp]);       
      ChangingWorlds = true; 
    }
  else Screen = SDONE;
 }

 return false;
}

bool DeProcessOption()
{
 if(Screen == SSAVE) { isConfirm = false; IconY = StartY; IconX = StartX; }
 if(Screen == STITLE) 
 {
  freeWList(Worlds[CurrentWorld]);
  return true;
 }
 else{ ResetAllWorlds();  Screen = STITLE; IconY = StartY; IconX = StartX; }
 return false;
}
