#ifndef gf_included_Menu_h
#define gf_included_Menu_h

#define STITLE 0
#define SHELP1 1
#define SHELP2 2
#define SHELP3 3
#define SWORLD 4
#define SDONE 5
#define SSAVE 6

char* GetWorldBackground();
char* GetWorldSky();
char* GetWorldWall();

void PassOnName(char* Name);
char* GetPlayerName();

void NextWorld();  //Switches the menu into the next world in the game.

//This tells the Painter and the Driver what Screen we're currently on
//that way it can properly handle key input and paint the right thing.
int GetScreen();

//Puts the player cursor where it's needed, depending on the screen.
void IncreaseMenuOption();
void DecreaseMenuOption();

char* GetPlayerFile();
bool TimeToLoadPlayer(); //If it's time to load the player...

bool Replay(); //Tells me if the player chooses a level for replay.

//Tells me if the player is playing the game right now or not.
bool InGame();

//It goes to the appropriate screen based on the option selected.
//Returns true if the user just quit.
bool ProcessOption();

//It goes back to a previous screen.  Returns true if the user just quit.
bool DeProcessOption();

//Get the world name.
char* GetWorldName();

//Level name being played.
char* GetLevelName();

//The filename to load the appropriate map.
char* GetLevelByFile();
int GetLevelByID();
int GetLevelByNumMoves();
bool ChangedWorld();

//Takes us back to the menu.
void OutOfGame();

//These gives the coordinates to the Painter on where to draw the icon.
double GetMenuX(bool Anim);
double GetMenuY(bool Anim);
double GetWorldX();
double GetWorldY();

bool ShiftingLeft(); //This tells someone if the map should be shifting left or right during a world transfer.
void SuccessfulLoad();
bool Confirm();
bool isNewGame();
char* GetNewName();
void ClearNewName();
void ChangeNewName(char c);
void BackspaceNewName();
void SetTotalMoves(int pTotalMoves);
int GetTotalMoves();
void SetTotalComplete(int pTotalComplete);
int GetTotalComplete();

char* GetSaveInfo();
void SetupSaveMenu(char pCallback[]);
void ResetWorldMap();
void UpdateWorldMap(int pLevelID, int pNumMoves); //Tells the menu to update player display information.

#endif
