#include<stdlib.h>
#include <stdio.h>

#include "World.h"

//At the moment, my source code only makes ONE world.
//Don't worry, I'll change this later when I get more game content
//together.  As it is, I've only got a few levels.
//If you wanna contribute, go get my Editor and give me a hand with this thing.

World MakeEmptyWorld()
{
 World newWorld; 

 newWorld.Head = NULL;
 newWorld.Tail = NULL;
 newWorld.Current = newWorld.Head;
     
 return newWorld;
}

void freeWList(World theList)
{
	theList.Current = theList.Head;
	while (theList.Current != NULL) 
	{ 	 
		theList.Current = theList.Head->next;
		free(theList.Head);
		theList.Head = theList.Current;
	}	
}

World nextLevel(World theWorld)
{
 if(theWorld.Current->next != NULL)
   theWorld.Current = theWorld.Current->next;
 else theWorld.Current = theWorld.Head;
 return theWorld;     
}

World prevLevel(World theWorld)
{
 if(theWorld.Current->prev != NULL)
   theWorld.Current = theWorld.Current->prev;     
 else theWorld.Current = theWorld.Tail;
 return theWorld;
}

bool ChangeWorld(World theList)
{
 if(theList.Current->LevelID == 0) return true;
 else return false;    
}

World AddLevel(World theList, char* pName, int ID,  char* pFile, double pX, double pY)
{      
	LevelNode* newNode = (LevelNode*) malloc(sizeof(LevelNode));	
    
    newNode->Filename = pFile;
	newNode->Name = pName;
    newNode->X = pX;
    newNode->Y = pY;
    newNode->LevelID = ID;
    newNode->NumMoves = -1;

    newNode->prev = NULL;
	newNode->next = NULL;

	if (theList.Head == NULL)
	{
		theList.Head = newNode;
		theList.Current = theList.Head;
		theList.Tail = theList.Current;
	}
	else
	{
		theList.Current = theList.Head;  
		while(theList.Current->next != NULL)
		{
			theList.Current = theList.Current->next;
        }

		theList.Current->next = newNode;
		newNode->prev = theList.Current;
        theList.Tail = theList.Current->next;
	}

	return theList;            
}

World ResetWorld(World theWorld)
{
 theWorld.Current = theWorld.Head;
 return theWorld;
}

World LoadWorld(char* filename)
{
 int i;
 
 World theWorld; 
 theWorld = MakeEmptyWorld();
 
 FILE* NewWorld = fopen(filename,"r");

 if (!NewWorld)
 {
  printf("World not found.\r\n");
  exit(1);
 }

 char nextLine[90];
 fgets(nextLine,90,NewWorld);
 char* WorldName = (char*) malloc(256);
 char* BackG = (char*) malloc(256);
 char* SkyG = (char*) malloc(256);
 char* WallG = (char*) malloc(256);   
 sscanf(nextLine, "%s %s %s %s", WorldName, BackG, SkyG, WallG);
 
 theWorld.Name = WorldName;
 theWorld.Backg = BackG;
 theWorld.Sky = SkyG;
 theWorld.Wall = WallG;
 
 printf("%s %s %s %s\n", theWorld.Name, theWorld.Backg, theWorld.Sky, theWorld.Wall);
 
 while(fgets(nextLine,90,NewWorld) != NULL)
 {
  double X, Y;
  char* Filename = (char*) malloc(256);
  char* Name = (char*) malloc(256);
  int ID;
  sscanf(nextLine, "%d %lf %lf %s %s", &ID, &X, &Y, Filename, Name);
  printf("%f %f %s %s\n",  X, Y, Filename, Name);
  theWorld = AddLevel(theWorld, Name, ID, Filename, X, Y);
 }
 
 fclose(NewWorld);
 theWorld = ResetWorld(theWorld);
 return theWorld;
}

World* LoadWorlds(int& NumWorlds)
{
 FILE* WorldList = fopen("worlds.cfg","r");

 if (!WorldList)
 {
  printf("World list not found.\r\n");
  exit(1);
 }

 char nextLine[20];
 fgets(nextLine, 20, WorldList);
 sscanf(nextLine, "%d", &NumWorlds);
 printf("%d worlds found.\n", NumWorlds);
 World* newWorld = (World*) malloc(sizeof(World)*NumWorlds);
  
 char* nextFile = (char*) malloc(256);
 
 for(int i = 0; i < NumWorlds; i++)
 { 
  fgets(nextLine,20,WorldList); 
  sscanf(nextLine, "%s", nextFile); 
 
  newWorld[i] = LoadWorld(nextFile);
 }
 fclose(WorldList); 

 return newWorld;
}
