#ifndef gf_included_World_h
#define gf_included_World_h

typedef struct levelnode LevelNode;

//You'll notice that this is yet another linked list.  This one is doubly linked,
//just so that the player can go back and forth through the list.
//A world is simply a collection of maps.  

struct levelnode
{
 char* Name;   //The name of the map.
 int LevelID; //the identifier of the level for the player files.
 int NumMoves;
 char* Filename;  //The filename used to load the map.
 double X;   //The X value of where the level is located on the world screen.  This is for Painter.
 double Y;   //Y value for Painter.
 
 LevelNode* prev;
 LevelNode* next;        
};

struct world
{
 char* Name;  //The name of the world.
 char* Backg; //Filename for background.
 char* Sky; //Filename for sky background.
 char* Wall; //Filename for wall background.
 
 LevelNode* Head;
 LevelNode* Tail;
 LevelNode* Current;        
};

typedef struct world World;

bool ChangeWorld(World theList);
void freeWList(World theList);
World MakeEmptyWorld();
World ResetWorld(World theWorld);
World nextLevel(World theWorld);
World prevLevel(World theWorld);
World AddLevel(World theList, char* pName, int ID, char* pFile, double pX, double pY);
World LoadWorld();
World* LoadWorlds(int& NumWorlds);

#endif

