#include<stdlib.h>
#include <stdio.h>
#include <string.h>

#include "player.h"
#include "Menu.h"

Player thePlayer;

int OnMove = 0;

void FreePlayer()
{
 thePlayer.Current = thePlayer.Head;
 while(thePlayer.Current != NULL)   
 {
  thePlayer.Head = thePlayer.Current;
  thePlayer.Current = thePlayer.Current->Next;
  free(thePlayer.Head);                        
 } 
}

void RecalculatePlayer()
{
 thePlayer.TotalMoves = 0;
 thePlayer.TotalComplete = 0;
 thePlayer.Current = thePlayer.Head;
 while( thePlayer.Current != NULL )
 {
   thePlayer.TotalComplete++;
   thePlayer.TotalMoves += thePlayer.Current->NumMoves;
   thePlayer.Current = thePlayer.Current->Next;
 }    
 SetTotalMoves(thePlayer.TotalMoves);
 SetTotalComplete(thePlayer.TotalComplete);
}

void GotoLevel(int pLevelID)
{
 thePlayer.Current = thePlayer.Head;
 while( thePlayer.Current != NULL )
 {
   if(thePlayer.Current->LevelID == pLevelID) return;
   thePlayer.Current = thePlayer.Current->Next;
 }
 
 printf("Abnormality in player file detected.\n");
}

Direction GetNextPlayerMove()
{
 Direction theMove = thePlayer.Current->MoveList[OnMove];         
 OnMove++;
 if(OnMove >= thePlayer.Current->NumMoves) OnMove = 0;
 return theMove;
}

bool Exists(int pLevelID, int pNumMoves)
{
 thePlayer.Current = thePlayer.Head;
 while( thePlayer.Current != NULL )
 {
  if(thePlayer.Current->LevelID == pLevelID)
  {
   if(pNumMoves < thePlayer.Current->NumMoves) return true;
   else return false;                              
  }
  thePlayer.Current = thePlayer.Current->Next;
 }    
 return false;    
}

bool SaveData(int pLevelID, int pNumMoves)
{
 if(Exists(pLevelID, pNumMoves))
 {
  thePlayer.Current->NumMoves = pNumMoves;
  if(thePlayer.Current->MoveList != NULL) free(thePlayer.Current->MoveList);
  UpdateWorldMap(pLevelID, pNumMoves);
  return true;
 }   
 else if(thePlayer.Current == NULL)
 {
  Solution* newNode = (Solution*) malloc(256);     
  newNode->Next = NULL;
  newNode->LevelID = pLevelID;
  newNode->MoveList = NULL;
  newNode->NumMoves = pNumMoves;
  thePlayer.Current = thePlayer.Head;
  if(thePlayer.Current == NULL) 
  {
   thePlayer.Head = newNode;
   thePlayer.Current = thePlayer.Head; 
  }
  else
  {
   while(thePlayer.Current->Next != NULL) thePlayer.Current = thePlayer.Current->Next;
  
   thePlayer.Current->Next = newNode;
   thePlayer.Current = thePlayer.Current->Next;
  } 
  UpdateWorldMap(pLevelID, pNumMoves);        
  return true;
 }  
 return false;
}

//Due to the search above, we are guaranteed to be at the right spot if this is called
//immediately after the function above and at no other time.
void SaveRecording()
{
 if(thePlayer.Current->MoveList != NULL) free(thePlayer.Current->MoveList);
 thePlayer.Current->MoveList = (Direction*) malloc(sizeof(Direction) * thePlayer.Current->NumMoves);
 
 FILE* Ftemp = fopen("temp.tmp", "r");
 
 if (!Ftemp)
 {
  printf("Player File not entirely saved.\r\n");
 }
 
 char nextLine[1];
 for(int i = 0; i < thePlayer.Current->NumMoves; i++)
 {
  nextLine[0] = fgetc(Ftemp);
  if(nextLine[0] != ' ')
    thePlayer.Current->MoveList[i] = (Direction) atoi(nextLine);
  else i--;
 }
 fclose(Ftemp);
}

void LoadPlayer()
{   
 if(!TimeToLoadPlayer()) return;

 char* PFile = GetPlayerFile();
 char Action = PFile[0];
 PFile++;
 FreePlayer();
 ResetWorldMap();
// printf("%s", PFile);
 
 if(Action == 'C')
 {
  FILE* FSave = fopen(PFile,"r");

  if (!FSave)
  {
   printf("Player File not found.\r\n");
   exit(1);
  }

  char nextLine[60];
  fgets(nextLine,60,FSave);
  char* Name = (char*) malloc(128);
  thePlayer.TotalComplete = 0;
  thePlayer.TotalMoves = 0;

  sscanf(nextLine, "%d %d %s", &thePlayer.TotalComplete, &thePlayer.TotalMoves, Name);
 
  thePlayer.Head = NULL;
  thePlayer.Current = NULL;
  strcpy(thePlayer.Name, Name);

  int ID;
  int NumMoves; 
  while(fgets(nextLine,60,FSave) != NULL)
  {
   ID = 0;
   NumMoves = 0;
   sscanf(nextLine, "%d %d\n", &ID, &NumMoves);
   SaveData(ID, NumMoves);
   if(thePlayer.Current->MoveList != NULL) free(thePlayer.Current->MoveList);
   thePlayer.Current->MoveList = (Direction*) malloc(sizeof(Direction) * thePlayer.Current->NumMoves);
   char nextM[2];
 //  printf("%d %d\n", ID, NumMoves);
   for(int i = 0; i < thePlayer.Current->NumMoves; i++)
   {
    nextM[0] = fgetc(FSave);
    nextM[1] = fgetc(FSave);
    thePlayer.Current->MoveList[i] = (Direction) atoi(nextM); 
 //   printf("%d ", thePlayer.Current->MoveList[i]);
   } 
 //  printf("\n");
   fgets(nextLine,60,FSave);  
  }
  fclose(FSave);    
 }
 else if(Action == 'D' || Action == 'N')
 {              
  thePlayer.Current = NULL;
  thePlayer.Head = NULL;
  if(Action == 'D') strcpy(thePlayer.Name, "<nothing>");
  else { strcpy(thePlayer.Name, GetNewName()); ClearNewName(); PassOnName(thePlayer.Name); }

  thePlayer.TotalComplete = 0;
  thePlayer.TotalMoves = 0;
 }
 
 PassOnName(thePlayer.Name);
 RecalculatePlayer();
 if(Action != 'D') SuccessfulLoad();
 if(Action == 'D' || Action == 'N') SavePlayer();
}

void SetupSaving()
{
 FILE* FSave = fopen("player1.sav", "r");
 char Callback[80];
 char nextLine[20];
 fgets(nextLine,20,FSave);
 strcpy(Callback, nextLine);
 strcat(Callback, " ");
 fclose(FSave);

 FSave = fopen("player2.sav", "r");
 fgets(nextLine,20,FSave);
 strcat(Callback, nextLine);
 strcat(Callback, " ");
 fclose(FSave);

 FSave = fopen("player3.sav", "r");
 fgets(nextLine,20,FSave);
 strcat(Callback, nextLine);
 strcat(Callback, " ");
 fclose(FSave);

 FSave = fopen("player4.sav", "r");
 fgets(nextLine,20,FSave);
 strcat(Callback, nextLine);
 strcat(Callback, " ");
 fclose(FSave);   
 
 SetupSaveMenu(Callback);
}

void SavePlayer()
{
 char* PFile = GetPlayerFile();
 PFile++;

 FILE* FSave = fopen(PFile,"w");

 if (!FSave)
 {
  printf("Player File not found.\r\n");
  exit(1);
 }
 
 fprintf(FSave, "%d %d %s\n", thePlayer.TotalComplete, thePlayer.TotalMoves, thePlayer.Name);    

 thePlayer.Current = thePlayer.Head; 
 while(thePlayer.Current != NULL)
 {
  fprintf(FSave, "%d %d\n", thePlayer.Current->LevelID, thePlayer.Current->NumMoves);
  for(int i = 0; i < thePlayer.Current->NumMoves; i++)
  {
   fprintf(FSave, "%d ", thePlayer.Current->MoveList[i]);
  }
  fprintf(FSave, "\n");
  thePlayer.Current = thePlayer.Current->Next;
 }
 fclose(FSave);  
 SetupSaving();
}
